-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009 - 2016 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org

Talents.talents_def.T_BLOCK.name = "Block"
Talents.talents_def.T_BLOCK.type = {"technique/objects", 1}
Talents.talents_def.T_BLOCK.cooldown = function(self, t)
		return 5
		--return 8 - util.bound(self:getTalentLevelRaw(t), 1, 5)
	end
Talents.talents_def.T_BLOCK.speed = 'shield'
Talents.talents_def.T_BLOCK.points = 5
Talents.talents_def.T_BLOCK.hard_cap = 5
Talents.talents_def.T_BLOCK.range = 1
Talents.talents_def.T_BLOCK.requires_target = true
Talents.talents_def.T_BLOCK.tactical = { ATTACK = 3, DEFEND = 3 }
Talents.talents_def.T_BLOCK.on_pre_use = function(self, t, silent) if not self:hasShield() then if not silent then game.logPlayer(self, "You require a shield to use this talent.") end return false end return true end
Talents.talents_def.T_BLOCK.getProperties = function(self, t)
		local shield1, combat1, shield2, combat2 = self:hasShield()
		--if not shield then return nil end
		local p = {
			--sp = (combat1 and combat1.spellplated or false) or (combat2 and combat2.spellplated or false),
			ref = (combat1 and combat1.reflective or false) or (combat2 and combat2.reflective or false),
			br = (combat1 and combat1.bloodruned or false) or (combat2 and combat2.bloodruned or false),
		}
		return p
	end
Talents.talents_def.T_BLOCK.getBlockValue = function(self, t) return self:combatShieldBlock() or 0 end
Talents.talents_def.T_BLOCK.getBlockedTypes = function(self, t) -- Delete me, I'm not used
		local shield1, combat1, shield2, combat2 = self:hasShield()
		local bt = {[DamageType.PHYSICAL]=true}
		if not shield1 then return bt, "error!" end

		if not self:attr("spectral_shield") then
			if shield1.wielder.resists then for res, v in pairs(shield1.wielder.resists) do if v > 0 then bt[res] = true end end end
			if shield1.wielder.on_melee_hit then for res, v in pairs(shield1.wielder.on_melee_hit) do if v > 0 then bt[res] = true end end end
			if shield2 and shield2.wielder.resists then for res, v in pairs(shield2.wielder.resists) do if v > 0 then bt[res] = true end end end
			if shield2 and shield2.wielder.on_melee_hit then for res, v in pairs(shield2.wielder.on_melee_hit) do if v > 0 then bt[res] = true end end end
		else
			bt[DamageType.FIRE] = true
			bt[DamageType.LIGHTNING] = true
			bt[DamageType.COLD] = true
			bt[DamageType.ACID] = true
			bt[DamageType.NATURE] = true
			bt[DamageType.BLIGHT] = true
			bt[DamageType.LIGHT] = true
			bt[DamageType.DARKNESS] = true
			bt[DamageType.ARCANE] = true
			bt[DamageType.MIND] = true
			bt[DamageType.TEMPORAL] = true
		end

		bt.all = nil

		local list = table.keys(bt)
		local n = #list
		if n < 1 then return bt, "(error 2)" end
		local e_string = ""
		if n == 1 then
			e_string = DamageType.dam_def[next(bt)].name
		else
			for i = 1, #list do if DamageType.dam_def[list[i]] then
				list[i] = DamageType.dam_def[list[i]].name
			end end
			e_string = table.concatNice(list, ", ", " and ")
		end
		return bt, e_string
	end
Talents.talents_def.T_BLOCK.action = function(self, t)
		local properties = t.getProperties(self, t)
		self:setEffect(self.EFF_BLOCKING, 1 + (self:knowTalent(self.T_ETERNAL_GUARD) and 1 or 0), {power = t.getBlockValue(self, t), properties=properties})
		return true
	end
Talents.talents_def.T_BLOCK.info = function(self, t)
		local properties = t.getProperties(self, t)
		local sp_text = ""
		local ref_text = ""
		local br_text = ""
		if properties.sp then
			sp_text = (" Increases your spell save by %d for that turn."):format(t.getBlockValue(self, t))
		end
		if properties.ref then
			ref_text = " Reflects all blocked damage back to the source."
		end
		if properties.br then
			br_text = " All blocked damage heals the wielder."
		end
		return ([[Raise your shield into blocking position for one turn, allowing you to reduce all incoming damage by %d over the next turn. For non physical damage hits, your effective block value is multiplied by your Spell Save and divided by 100.%s%s%s
	If you are hit with an attack of more than 50%% of your maximum life, the entire attack will be blocked and your block will break.
	If you block all of an attack's damage, the attacker will be vulnerable to a deadly counterstrike (a normal attack will instead deal 200%% damage) for one turn.]]):format(t.getBlockValue(self, t), sp_text, ref_text, br_text)
	end

Talents.talents_def.T_ETERNAL_GUARD.info = function(self, t)
		return ([[Your block now lasts 1 more turn and your guard is not broken by huge hits.]])
		:format()
	end
	
Talents.talents_def.T_SPECTRAL_SHIELD.passives = function(self, t, p)
		self:talentTemporaryValue(p, "block_extra_types", {[DamageType.FIRE] = true, [DamageType.COLD] = true, [DamageType.LIGHTNING] = true, [DamageType.ACID] = true, [DamageType.ARCANE] = true, [DamageType.NATURE] = true, [DamageType.BLIGHT] = true, [DamageType.LIGHT] = true, [DamageType.DARKNESS] = true, [DamageType.MIND] = true, [DamageType.TEMPORAL] = true})
	end
	
Talents.talents_def.T_SPECTRAL_SHIELD.info = function(self, t)
		return ([[By infusing your shield with raw magic, your block can now block any damage type without the Spell Save multiplier.]])
		:format()
	end
	
Talents.talents_def.T_SHIELD_EXPERTISE.on_learn = nil
Talents.talents_def.T_SHIELD_EXPERTISE.on_unlearn = nil
Talents.talents_def.T_SHIELD_EXPERTISE.saves_factor = function(self, t)	return self:combatTalentScale(t, 10, 20, 0.75)/100 end
Talents.talents_def.T_SHIELD_EXPERTISE.info = function(self, t)
	local savesfactor = t.saves_factor(self, t)
	local physbonus, _, _ = self:getAttrChange("combat_physresist", 0, savesfactor*self:combatShieldBlock(), "combatPhysicalResist", true)
	local spellbonus, _, _ = self:getAttrChange("combat_spellresist", 0, savesfactor*self:combatShieldBlock(), "combatSpellResist", true)
		return ([[Improves your damage and skill with shield-based skills, and increases your Spell and Physical Saves by %d%% of your block value, while you are blocking.
	Effective physical save bonus: %d.
	Effective spell save bonus: %d.]]):format(savesfactor*100, physbonus, spellbonus)
	end

Talents.talents_def.T_SPELL_SHIELD.multiplier = function(self, t) return self:combatTalentScale(t, 0, 100, 0.75)/100 end
Talents.talents_def.T_SPELL_SHIELD.passives = function(self, t, p)
		self:talentTemporaryValue(p, "combat_spellresist", self:getTalentLevel(t) * 9)
		self:talentTemporaryValue(p, "combat_spellresist_blockmult", t.multiplier(self, t))
	end
Talents.talents_def.T_SPELL_SHIELD.info = function(self, t)
		return ([[Rigorous training allows you to be more resistant to some spell effects (+%d spell save).
	This also increases your ability to block non-physical damage (+%d%% effective spell save).]]):format(self:getTalentLevel(t) * 9, t.multiplier(self, t)*100)
	end