local class = require"engine.class"
local ActorTalents = require "engine.interface.ActorTalents"
local ActorTemporaryEffects = require "engine.interface.ActorTemporaryEffects"
local Birther = require "engine.Birther"
local DamageType = require "engine.DamageType"
local Map = require "engine.Map"
local chat = require "engine.Chat"
local PartyLore = require "mod.class.interface.PartyLore"


class:bindHook("ToME:load", function(self, data)
	ActorTalents:loadDefinition("/data-blockupdate/blockupdate.lua")
	ActorTemporaryEffects:loadDefinition("/data-blockupdate/physical.lua")
end)

class:bindHook("Object:descWielder", function(self, data)
	if data.w.stats_on_block then
		data.compare_scaled(data.w.stats_on_block, data.compare_with, data.field, "combat_physresist", {"combatPhysicalResist", true}, "%+d #LAST#(%+d eff.)", "Physical save when Blocking: ")
		data.compare_scaled(data.w.stats_on_block, data.compare_with, data.field, "combat_spellresist", {"combatSpellResist", true}, "%+d #LAST#(%+d eff.)", "Spell save when Blocking: ")
		data.compare_scaled(data.w.stats_on_block, data.compare_with, data.field, "combat_mentalresist", {"combatMentalResist", true}, "%+d #LAST#(%+d eff.)", "Mental save when Blocking: ")
		data.compare_fields(data.w.stats_on_block, data.compare_with, data.field, "stamina_regen_when_hit", "%+.2f", "Stamina when hit while Blocking: ")
		data.compare_fields(data.w.stats_on_block, data.compare_with, data.field, "mana_regen_when_hit", "%+.2f", "Mana when hit while Blocking: ")
		data.compare_fields(data.w.stats_on_block, data.compare_with, data.field, "equilibrium_regen_when_hit", "%+.2f", "Equilibrium when hit while Blocking: ")
		data.compare_fields(data.w.stats_on_block, data.compare_with, data.field, "psi_regen_when_hit", "%+.2f", "Psi when hit while Blocking: ")
		data.compare_fields(data.w.stats_on_block, data.compare_with, data.field, "hate_regen_when_hit", "%+.2f", "Hate when hit while Blocking: ")
		data.compare_fields(data.w.stats_on_block, data.compare_with, data.field, "vim_regen_when_hit", "%+.2f", "Vim when hit while Blocking: ")
		
		local onhit = tstring{}
		local found = false
		local onhit_combat = { on_melee_hit = {} }
		for i, v in pairs(data.w.stats_on_block.on_melee_hit or {}) do
			local def = DamageType.dam_def[i]
			if def and def.tdesc then
				local d = def.tdesc(v)
				found = true
				onhit:add(d, {"color","LAST"}, true)
			else
				onhit_combat.on_melee_hit[i] = v
			end
		end
		
		data.compare_table_fields(onhit_combat, data.compare_with, data.field, "on_melee_hit", "%d", "Damage when hit (Melee) while Blocking: ", function(item)
			local col = (DamageType.dam_def[item] and DamageType.dam_def[item].text_color or "#WHITE#"):toTString()
			return col[2],(" %s"):format(DamageType.dam_def[item].name),{"color","LAST"}
		end)
	end
	
end)

class:bindHook("Object:descCombat", function(self, data)
	if data.combat.reflective then
		data.desc:add("Blocked damage is reflected back at attacker.", true)
	end
	if data.combat.bloodruned then
		data.desc:add("Blocked damage is converted into healing.", true)
	end
end)
